<template>

	<transition name="slide-fade">
		
		<div :class="responsiveClassSidebar" :style="sidebar ? 'width:45px' : ''">
			<div class="toggle-content"  @click.prevent="toggleSidebarResponsive()"><a href="#"><i class="  ti-book" ></i></a></div>
			<div class="custom-scroll custom-scroll-dark" v-if="courseLoaded" >
				<div class="content-title"  v-show=" ! sidebar">
					<h4>{{ course.title }}</h4>
					 <p>{{ course.grade }}</p>
					<a id="threepoints" href="#" @click.prevent="toggleSidebar()"><i class="ti-more-alt"></i></a>
				</div>
				<div class="content-sesiones ">
					<div class="panel panel-success">
						<template v-for="(weeks, week_index) in course.content.weeks">
						    <ul class="nav  tabs-nav" role="tablist" :key="week_index">
						        <li class="nav-item ">
							        <a :href="`#collapse-${week_index + 1}`" :aria-controls="`tema-${week_index + 1}`" role="tab" data-toggle="collapse" aria-expanded="true" class="nav-link semana">
							        	<b> {{ sidebar ? `S${week_index + 1}` : `Semana ${week_index + 1}: ${weeks.name}` }} </b>
							        </a>
						        </li>
						    </ul>
						    <div :id="`collapse-${week_index + 1}`" class="panel-collapse collapse in" :key="week_index">
								<ul class="list-group">
									<li :class="defineClass(session)" v-for="(session, session_index) in weeks.sessions" v-if="session.type=='content'" :key="session_index">
					            		<a @click.prevent="changeSession(week_index, session_index, session)" style="cursor:pointer;" :aria-controls="`tema-${week_index + 1}`" role="tab" data-toggle="tab" aria-expanded="true"
										 :class="`${session.completed ? 'nav-link active' : 'nav-link'} ${!sidebar ? 'ellipsis' : ''} ${isSessionActive(week_index, session_index) ? 'session-selected' : ''}`"
										 > 
						            		<span  v-show=" ! sidebar">{{ session.name }}</span>
						            	</a>										
									</li>
								</ul>
						        <ul id="ev" class="list-group" v-for="(session, session_index) in weeks.sessions" v-if="session.type=='quiz' || session.type=='eval'" :key="session_index">
						            <li :class="defineClass(session)">
						            	<a @click.prevent="changeSession(week_index, session_index, session)" style="cursor:pointer;" :aria-controls="`tema-${week_index + 1}`" role="tab" data-toggle="tab" aria-expanded="true" :class="`${session.completed ? 'nav-link active' : 'nav-link' } ${!sidebar ? 'ellipsis' : ''} ${isSessionActive(week_index, session_index) ? 'session-selected' : ''}`"> 
						            		<span  v-show=" ! sidebar">{{ session.name }}</span>
						            	</a>
						            </li>
						        </ul>
						    </div>
						</template>
					</div>
				</div>
			</div>				
		</div>
	</transition>
</template>

<script>

	import { mapGetters, mapActions  } from 'vuex'
	export default{
		data(){
			return {
				sidebarResponsive : false,
			}
		},
		props: {
			isPreview: {
				type: Boolean,
				required: false,
				default: false,
			}
		},
		computed: {  		
	  		...mapGetters([
			  'currentCourseSessionIndexes',
		      'course',
		      'hasStartedSession',
		      'sidebar',
			]),
		    courseLoaded() {
		        return this.course.name != ''
			},
			responsiveClassSidebar(){
				let _class = "content-sidebar session-bar "
				if(this.sidebar)
					_class+="col-md-1 "
				else
					_class+="col-md-3 "
				if(this.sidebarResponsive)
					_class+="sidebar-responsive2"
				return _class
			}
	  	},
		 methods: {
			isSessionActive(week_index, session_index){
				return week_index == this.currentCourseSessionIndexes.week && session_index == this.currentCourseSessionIndexes.session
			},
			 toggleSidebarResponsive(){
				 this.sidebarResponsive = ! this.sidebarResponsive
			 },
			getLastWeekSeen(){
				let last_week = -1
				let last_session = -1
				this.course.content.weeks.every(({sessions}, week_index) => {
					sessions.every( (session, session_index) => {
						if(!session.completed){
							last_week = week_index
							last_session = session_index
							return false
						} else {
							return true
						}
					})
					return last_week == -1

				})
				return {last_week, last_session}

			},
			defineClass(session) {
				let type = (session.type == 'quiz' || session.type == 'eval' ) ? 'nav-li nav-evaluacion' : 'nav-li'
				return session.completed ? `nav-item ${type} activo` : `nav-item ${type}`
			},
		    ...mapActions([
		      'getCourse',
		      'getCoursePreview',
		      'changeCurrentSession',
		      'toggleSidebar',
		      'displayModal',
		      'togglePreview',
		    ]),
			changeSession(week_index, session_index, session) {
		      let isLastSession = this.course.content.weeks[this.getLastWeekSeen().last_week].sessions[this.getLastWeekSeen().last_session] == session
		      if(! this.hasStartedSession){
				  if( isLastSession || session.completed || this.isPreview){
					this.changeCurrentSession({ week: week_index, session: session_index })
				  }
				  else{
					toastr.warning(`Aun no puedes acceder a estos contenidos, avanza para desbloquear mas contenido`)
				 }
			  }
			  else{
				  toastr.warning(`Termina la sesión actual para ver otro contenido`)
			  }
		    }
		},
		created(){
			let id = window.location.href.split('/').pop()
			if(!this.isPreview){
				this.getCourse(id).then(()=>{
					this.changeSession(this.getLastWeekSeen().last_week, this.getLastWeekSeen().last_session, this.course.content.weeks[this.getLastWeekSeen().last_week].sessions[this.getLastWeekSeen().last_session])
					this.displayModal('begin')
				})
			}
			else{
				this.togglePreview()
				this.getCoursePreview(id).then(()=>{
					this.changeSession(this.getLastWeekSeen().last_week, this.getLastWeekSeen().last_session, this.course.content.weeks[this.getLastWeekSeen().last_week].sessions[this.getLastWeekSeen().last_session])
					this.displayModal('begin')
				})
			}
		}
	}
	
</script>
<style>

.session-selected{
	background: rgba(0,0,0,0.25)!important;
	color: white !important;
}

.slide-fade-enter-active {
  transition: all .3s ease;
}
.slide-fade-leave-active {
  transition: all .8s cubic-bezier(1.0, 0.5, 0.8, 1.0);
}
.slide-fade-enter, .slide-fade-leave-to{
  transform: translateX(10px);
  opacity: 0;
}

.no-pad{
	padding-right: 0px !important;
	padding-left: 0px !important;
}
</style>